// JukePlugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"

// standard windows headers
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>

#include "JukePlugin.h"

HINSTANCE hInstance = NULL;
HWND hWnd = NULL;
HANDLE hThread = NULL;

CHAR m_buffer[8192] = {0};
UCHAR m_keys[256] = {0};

#define WINDOW_NAME			"Plugin"
#define WINDOW_CLASS		"Plugin"

#define WINDOW_STYLE		WS_OVERLAPPEDWINDOW

#define PLUGIN_NAME			"Test Plugin"
#define PLUGIN_AUTHOR		"Ben Baker"
#define PLUGIN_VERSION		"1.0"
#define PLUGIN_DESCRIPTION	"This is the plugin description"

DWORD WINAPI ReadInput(LPVOID lpParam);

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
			hInstance = (HINSTANCE) hModule;
			DisableThreadLibraryCalls(hInstance);
			break;
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

JUKEPLUGIN_API PCHAR __stdcall Juke_GetPluginInfo(int Value)
{
	sprintf(m_buffer, "%s|%s|%s|%s", PLUGIN_NAME, PLUGIN_AUTHOR, PLUGIN_VERSION, PLUGIN_DESCRIPTION);

	return m_buffer;
}

JUKEPLUGIN_API int __stdcall Juke_Initialize(int Value)
{
	// MessageBox(NULL, NULL, "Juke_Initialize", MB_OK);

	//DWORD dwThreadId= NULL, dwThrdParam = 1;

	//hThread = CreateThread(NULL, 0, ReadInput, &dwThrdParam, 0, &dwThreadId);

	//if (hThread == NULL) 
	//	return 0;

	return 1;
}

JUKEPLUGIN_API int __stdcall Juke_Shutdown(int Value)
{
	// MessageBox(NULL, NULL, "Juke_Shutdown", MB_OK);

	//if(hThread != NULL)
	//	CloseHandle(hThread);

	//WaitForSingleObject(hThread, INFINITE);

	return 1;
}

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_DESTROY:
			PostQuitMessage(WM_QUIT);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam); 
	}
	return 0;
}

JUKEPLUGIN_API int __stdcall Juke_Configure(HWND hWndParent)
{

	MSG msg;
	WNDCLASSEX wcex = {0};

	wcex.cbSize = sizeof(WNDCLASSEX);
	wcex.style = CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc = (WNDPROC)WndProc;
	wcex.cbClsExtra = 0;
	wcex.cbWndExtra = 0;
	wcex.hInstance = hInstance; 
	wcex.hIcon = LoadIcon(hInstance, IDI_APPLICATION);
	wcex.hCursor = LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground = (HBRUSH)(COLOR_WINDOW);
	wcex.lpszMenuName = NULL;
	wcex.lpszClassName = WINDOW_CLASS;
	wcex.hIconSm = NULL;

	if (!RegisterClassEx(&wcex))
		return 0;

	hWnd = CreateWindow(WINDOW_CLASS, WINDOW_NAME, WINDOW_STYLE,
	0, 0, 512, 512, hWndParent, NULL, hInstance, NULL);

	if (hWnd == NULL)
		return 0;

	ShowWindow(hWnd, SW_SHOWNORMAL);
	UpdateWindow(hWnd);

	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	UnregisterClass(WINDOW_CLASS, hInstance);

	return msg.wParam;
}

JUKEPLUGIN_API PCHAR __stdcall Juke_Command(PCHAR Name, PCHAR Value)
{
	strcpy(m_buffer, Value);

	if(strcmp(Name, "JUKE_PLUGIN_EVENT_GET") == 0)
	{
		for(int i=2; i<256; i++)
		{
			if(m_keys[i] > 0)
				sprintf(m_buffer, "PLUGIN_EVENT_KEYDOWN|%c", i);
		}
	}		

	return m_buffer;
}

DWORD WINAPI ReadInput(LPVOID lpParam)
{
	while(1)
	{
		for(int i=0; i<256; i++)
			m_keys[i] = (UCHAR) (GetAsyncKeyState(i) >> 8);
		
		Sleep(100);
	}

	return 1;
}
